/*
 *      COLORS.C
 *      Test ANSI colors
 *      klin, Mon Oct 19 12:50:59 1992
 *
 *      Libs:   -lcurses (-ltermcap on BSD)
 *      Test:   Start colors and see what happens.
 */

#include <stdio.h>

static char termcap[1024], termbuf[1024];

static char *_OP;
static char *_SF;
static char *_SB;
static int _CO;

main()
{
  char *getenv();
  int f, b;

  init(getenv("TERM"));

  for(b = 0; b < 8; b++)
    for(f = 0; f < 8; f++)
      cols(b, f);

}

_putch(c)
  int c;
{
  putchar(c);
}

cols(b, f)
  int b, f;
{
  char *tgoto();

  tputs(tgoto(_SB, b, b), 1, _putch);
  tputs(tgoto(_SF, f, f), 1, _putch);
  printf("  ----  %d ----------- %d ---------\n", b, f);
}

init(term)
  char *term;
{
  char *tgetstr();
  char *cp = termbuf;

  printf("TERM=%s -> %d\n", term, tgetent(termcap, term));
  _CO = tgetnum("Co");
  _SF = tgetstr("Sf", &cp);
  _SB = tgetstr("Sb", &cp);
  printf("colors=%d\n", _CO);
  put("Sf", _SF);
  put("Sb", _SB);
  put("op", _OP);
}

put(t, s)
  char *t, *s;
{
  printf("%s: ", t);
  if(s == NULL)
    printf("NULL\n");
  else {
    while(*s)
      printf("%2x ", *s++);
    putchar('\n');
  }
}
